<style>
  .examForm .q-table__bottom {
    min-height: 10px;
  }

</style>
<template>
  <div class="page-content examForm">
    <div style="margin-top:15px;">
    <q-btn v-if="multipleSelection&&multipleSelection.length>0" color="accent" size="sm" class="q-mr-md"
        @click="movePaperFile()" label="移动到" />
    <q-btn v-if="multipleSelection&&multipleSelection.length>0" color="accent" size="sm" class="q-mr-md"
        label="删除" @click="batchDelete()" />
    </div>

    <el-table :data="dataList" v-loading="loading" ref="multipleTable" :cell-class-name="isRender"
      @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55">
      </el-table-column>
      <el-table-column prop="PaperName" label="文件夹/试卷" width="300">
        <template slot-scope="scope">
          <div class="Exam_PaperName">
            <i v-if="scope.row.PaperType==1" title="文件夹" class="iconfont icon-weibiaoti5" style="color:#85CDFD;"></i>
            <i v-if="scope.row.PaperType==2" title="试卷" class="iconfont icon-icon-test1" style="color:#85CDFD;"></i>
            <div class="Exam_PaperName">
              <template v-if="scope.row.PaperType==1">
                <span style="cursor:pointer;" @click="getPaperChild(scope.row.PaperId)">
                  {{ scope.row.PaperName }}</span>
              </template>
              <template v-else>
                {{ scope.row.PaperName }}
                <q-tooltip v-if="scope.row.PaperName.length>10" :offset="[10, 10]">{{ scope.row.PaperName }}
                </q-tooltip>
              </template>
            </div>
          </div>
        </template>
      </el-table-column>
      <el-table-column prop="QuestionCount" label="题量">
        <template slot-scope="scope">
          <template v-if="scope.row.PaperType==1">
            ---
          </template>
          <template v-if="scope.row.PaperType==2">
            {{ scope.row.QuestionCount }}
          </template>
        </template>
      </el-table-column>
      <el-table-column prop="DifficultyTypeName" label="难度">
        <template slot-scope="scope">
          <template v-if="scope.row.PaperType==1">
            ---
          </template>
          <template v-if="scope.row.PaperType==2">
            {{ scope.row.DifficultyTypeName }}
          </template>
        </template>
      </el-table-column>
      <el-table-column prop="PublishCount" label="发布考试次数">
        <template slot-scope="scope">
          <template v-if="scope.row.PaperType==1">
            ---
          </template>
          <template v-if="scope.row.PaperType==2">
            {{ scope.row.PublishCount }}
          </template>
        </template>
      </el-table-column>
      <el-table-column prop="OpenStr" label="开放状态">
        <template slot-scope="scope">
          {{ scope.row.OpenStr }}
        </template>
      </el-table-column>
      <el-table-column prop="CreateByName" label="创建人">
        <template slot-scope="scope">
          {{ scope.row.CreateByName }}
        </template>
      </el-table-column>
      <el-table-column prop="CreateTimeStr" label="创建时间" width="148">
        <template slot-scope="scope">
          {{ scope.row.CreateTimeStr }}
        </template>
      </el-table-column>
      <el-table-column prop="ReviewerName" label="审核人">
        <template slot-scope="scope">
          {{ scope.row.ReviewerName }}
        </template>
      </el-table-column>
      <el-table-column prop="ExamineStatusStr" label="状态">
        <template slot-scope="scope">
          {{ scope.row.ExamineStatusStr }}
          <template v-if="scope.row.ExamineRemark">
            <q-tooltip :offset="[10, 10]">驳回原因：{{ scope.row.ExamineRemark }}
            </q-tooltip>
          </template>
        </template>
      </el-table-column>
      <el-table-column label="操作" width="180">
        <template slot-scope="scope">
          <template v-if="scope.row.PaperType==1">
            <q-btn flat size="xs" color="primary" style="font-weight:400" @click="showExamFolder(scope.row)" label="重命名"
              v-if="currentUserInfo.Id==scope.row.CreateBy" />
          </template>
          <template v-if="scope.row.PaperType==2">
            <q-btn flat size="xs" color="primary" style="font-weight:400" @click="goExameEdit(scope.row)" label="编辑"
              v-if="currentUserInfo.Id==scope.row.CreateBy &&(scope.row.ExamineStatus==0||scope.row.ExamineStatus==3||scope.row.ExamineStatus==4)" />
          </template>
          <q-btn-dropdown flat size="xs" color="dark" label="更多" style="margin-left: 10px">
            <q-list>
              <q-item clickable v-close-popup @click="submitAudit(scope.row)"
                v-if="scope.row.PaperType==2&&currentUserInfo.Id==scope.row.CreateBy &&(scope.row.ExamineStatus==0||scope.row.ExamineStatus==3||scope.row.ExamineStatus==4) ">
                <q-item-section>
                  <q-item-label>{{scope.row.ExamineStatus==0?'提交审核':"重新提交审核"}}</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="publishExam(scope.row)"
                v-if="scope.row.PaperType==2 &&currentUserInfo.Id==scope.row.CreateBy&&scope.row.ExamineStatus==2">
                <q-item-section>
                  <q-item-label>发布考试</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="showPaperInfo(scope.row)" v-if="scope.row.PaperType==2">
                <q-item-section>
                  <q-item-label>详情</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="movePaperInfo(scope.row)"
                v-if="currentUserInfo.Id==scope.row.CreateBy">
                <q-item-section>
                  <q-item-label>移动到</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="showOpenForm(scope.row)"
                v-if="currentUserInfo.Id==scope.row.CreateBy||IsPaperManager">
                <q-item-section>
                  <q-item-label>设置访问权限</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="copyPaperInfo(scope.row)" v-if="scope.row.PaperType==2">
                <q-item-section>
                  <q-item-label>复制</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="deletePaperInfo(scope.row)"
                v-if="currentUserInfo.Id==scope.row.CreateBy">
                <q-item-section>
                  <q-item-label>删除</q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-btn-dropdown>
        </template>
      </el-table-column>
    </el-table>
    <paperfolderForm v-if="isShowExamFolder" :saveObj="examObj" :FaParentId="msg.ParentId"  @close="closeExamForm"
       @success="refreshPage">
    </paperfolderForm>
    <movefolderForm v-if="isShowMoveFolder" :saveObj="examObj" :Ids="MoveIds"  @close="closeExamForm"
       @success="refreshPage">
    </movefolderForm>
    <setopenForm v-if="isShowSetOpenFolder" :saveObj="examObj"  @close="closeExamForm"  @success="refreshPage">
    </setopenForm>
  </div>
</template>
<script>
  import paperfolderForm from '../../components/exam/paperfolder-form'
  import movefolderForm from '../../components/exam/movefolder-form'
  import setopenForm from '../../components/exam/setopen-form'
  import {
    deletePaperInfo,
    copyPaperInfo,
    submitApproval
  } from '../../api/teacher/index';

  export default {
    components: {
      paperfolderForm,
      movefolderForm,
      setopenForm
    },
    meta: {
      title: "试卷库管理"
    },
    props: {
      dataList: {
        type: Array,
        default: null
      },
      loading: {
        type: Boolean,
        default: null
      }
    },
    data() {
      return {
        isShowExamFolder: false, //是否显示新增文件夹
        isShowMoveFolder: false, //是否显示
        isShowSetOpenFolder: false, //是否显示设置权限
        examObj:{},
        multipleSelection: [],
        MoveIds: '',
        currentUserInfo: {}, //当前登录用户
        IsPaperManager:false
      }
    },
    created() {
      let userinfo = this.getLocalStorage();
      this.currentUserInfo = userinfo;
      userinfo.ActionMenuList.map(x => { //判断权限
         if (x.FunctionCode == "Paper_Manager") { //判断是否是试卷管理员
          this.IsPaperManager = true;
        }
      })
      this.commonAccountId = this.currentUserInfo.AccountId;
    },
    mounted() {},
    methods: {
      isRender(row) {
        if (row.row.CreateBy != this.currentUserInfo.Id) {
          return 'disabled-column'
        }
      },
      //提交审核，重新提交审核
      submitAudit(item) {
        submitApproval({
          PaperId: item.PaperId
        }).then(res => {
          if (res.Code == 1) {
            this.$q.notify({
              icon: 'iconfont icon-chenggong',
              color: 'accent',
              timeout: 2000,
              message: '操作成功!',
              position: 'top'
            })
            this.refreshPage();
          }
        })
      },
      //全选
      handleSelectionChange(val) {
        this.multipleSelection = val;
        var myArray = [];
        if (this.multipleSelection.length > 0) {
          this.multipleSelection.forEach(x => {
            if (x.CreateBy == this.currentUserInfo.Id) {
              myArray.push(x.PaperId);
            }
          })
          this.MoveIds = myArray.toString();
        }
      },
      //移动文件
      movePaperFile() {
        if (this.multipleSelection.length == 0) {
          this.$q.notify({
            type: 'negative',
            position: "top",
            message: `请选择文件夹`
          })
          return
        } else {
          this.isShowMoveFolder = true;
        }
      },
      rowsClick(row, column, event) {
        this.$refs.examPaperTab.toggleRowExpansion(row);
      },
      getPaperChild(Id) {
        this.msg.ParentId = Id;
        this.refreshPage();
      },
      //点击编辑 跳转
      goExameEdit(item) {
        var obj = {
          Id: 0,
          ToParentId: this.msg.ParentId
        }
        if (item) {
          obj.Id = item.PaperId;
          obj.ToParentId = item.ParentId;
        }
        this.OpenNewUrl('/exam/paperEdit', obj)
      },
      //新增修改文件夹
      showExamFolder(obj) {
        this.examObj = obj;
        this.isShowExamFolder = true;
      },
      //实在开放权限
      showOpenForm(obj) {
        this.examObj = obj;
        this.isShowSetOpenFolder = true;
      },
      //关闭弹窗
      closeExamForm() {
        this.isShowExamFolder = false;
        this.isShowMoveFolder = false;
        this.isShowSetOpenFolder = false;
      },
      //发布考试
      publishExam(item) {
        let PaperId = 0;
        if (item) {
          PaperId = item.PaperId
        }
        this.OpenNewUrl('/exam/paperPublish', {
          PaperId: PaperId
        })
      },
      //试卷详情
      showPaperInfo(item) {
        let PaperId = 0;
        if (item) {
          PaperId = item.PaperId
        }
        this.OpenNewUrl('/exam/paperInfo', {
          Id: PaperId
        })
      },
      //移动到文件夹
      movePaperInfo(item) {
        this.examObj = item;
        this.isShowMoveFolder = true;
      },
      //复制试卷
      copyPaperInfo(item) {
        var msg = {
          PaperId: item.PaperId
        }
        var message = "是否要复制【" + item.PaperName + "】试卷?";
        this.$q.dialog({
          title: '提示信息',
          message: message,
          cancel: true,
          persistent: true,
          ok: "确定",
          cancel: "取消",
        }).onOk(() => {
          copyPaperInfo(msg).then(res => {
            if (res.Code == 1) {
              this.$q.notify({
                icon: 'iconfont icon-chenggong',
                color: 'accent',
                timeout: 2000,
                message: '操作成功!',
                position: 'top'
              })
              this.refreshPage();
            }
          });
        })
      },
      //批量删除
      batchDelete() {
        var msg = {
          PaperIds: this.MoveIds
        }
        var message = "是否要删除选中的文件信息";
        this.deletePaperCommon(msg, message);
      },
      //删除
      deletePaperInfo(item) {
        var msg = {
          PaperId: item.PaperId
        }
        var message = "";
        if (item.PaperType == 1) {
          message = "是否要删除【" + item.PaperName + "】及下面的内容?";
        } else {
          message = "是否要删除【" + item.PaperName + "】试卷?"
        }
        this.deletePaperCommon(msg, message);
      },
      deletePaperCommon(msg, tipMsg) {
        this.$q.dialog({
          title: '提示信息',
          message: tipMsg,
          cancel: true,
          persistent: true,
          ok: "确定",
          cancel: "取消",
        }).onOk(() => {
          deletePaperInfo(msg).then(res => {
            if (res.Code == 1) {
              this.$q.notify({
                icon: 'iconfont icon-chenggong',
                color: 'accent',
                timeout: 2000,
                message: '操作成功!',
                position: 'top'
              })
              this.refreshPage();
            }
          });
        })
      }
    }
  }

</script>
<style lang="sass">
  @import url('~assets/css/table.sass')

</style>
